/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.niederschrift.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class NiederschriftStatusAenderungExtendedDAO extends AbstractNiederschriftStatusAenderungDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: NiederschriftAndMaxZeitstempelNoFlush<br>
* Beschreibung: <br>
* EJBQL: select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = ?1 )<br>
* SQL: <br>
*/
@Override
public NiederschriftStatusAenderung findByNiederschriftAndMaxZeitstempel( @javax.annotation.Nonnull de.ivu.elect.business.niederschrift.entity.Niederschrift niederschrift) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("NiederschriftStatusAenderung.findByNiederschriftAndMaxZeitstempel" ,  niederschrift  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByNiederschriftAndMaxZeitstempel(): Miss");
        }

        cache.put(key, super.findByNiederschriftAndMaxZeitstempel( niederschrift  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByNiederschriftAndMaxZeitstempel(): Hit");
      }

      return (NiederschriftStatusAenderung) cache.lookup(key);
    }

    return super.findByNiederschriftAndMaxZeitstempel( niederschrift  );
}
/**
* Name: WahlAndMaxZeitstempelNoFlush<br>
* Beschreibung: <br>
* EJBQL: select nsa from NiederschriftStatusAenderung nsa where nsa.niederschrift.wahldurchfuehrungsgebiet.wahl = ?1 and nsa.zeitstempel = ( select max(nsa2.zeitstempel) from NiederschriftStatusAenderung nsa2 where nsa2.niederschrift = nsa.niederschrift )<br>
* SQL: <br>
*/
@Override
public java.util.List<NiederschriftStatusAenderung> findByWahlAndMaxZeitstempel( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("NiederschriftStatusAenderung.findByWahlAndMaxZeitstempel" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndMaxZeitstempel(): Miss");
        }

        cache.put(key, super.findByWahlAndMaxZeitstempel( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndMaxZeitstempel(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<NiederschriftStatusAenderung>) cache.lookup(key));
    }

    return super.findByWahlAndMaxZeitstempel( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
